﻿Type=Class
Version=2.71
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private cvs As Canvas
	Private mLbl As Label
	Private su As StringUtils
End Sub

Public Sub Initialize (Target As Object, EventName As String)

End Sub

Public Sub DesignerCreateView(Base As Panel, lbl As Label, props As Map)
	Dim bmp As Bitmap
	bmp.InitializeMutable(1dip,1dip)
	cvs.Initialize2(bmp)
	Base.AddView(lbl, 0, 0, Base.Width, Base.Height)
	mLbl = lbl
	Dim r As Reflector
	r.Target = mLbl
	r.RunMethod4("setPadding", Array As Object(0,0,0,0), Array As String("java.lang.int", "java.lang.int", "java.lang.int", "java.lang.int"))
	r.RunMethod4("setIncludeFontPadding", Array As Object(False), Array As String("java.lang.boolean"))
	setText2(mLbl.Text)
End Sub



Public Sub setText2(value As String)
Dim HighValue As Float  = 2
Dim LowValue As Float = 1
Dim CurrentValue 

mLbl.Text = value
Dim multipleLines As Boolean = mLbl.Text.Contains(CRLF)
'need to set actual start values so find Gross Start/Stop values
'first is linear Growth with some arbitrary 'large' value 'going with 30
'this can be fine tuned based on size of the display that you are aiming for/have available vs size of your CustomViews

Do While Not(CheckSize(HighValue, multipleLines))
	LowValue = HighValue
	HighValue = HighValue + 30
Loop

CurrentValue = (HighValue + LowValue)/2

'initial sizes set, now for binary approach


'adjust this to taste.  I like it at 1, and I think it looks very nice... can go a little larger for even faster times
'smaller for closer hit to actual optimum, but sacrificing a little speed

Dim ToleranceValue As Float
ToleranceValue = 1

Dim currentResult As Boolean
Do While (CurrentValue - LowValue) > ToleranceValue OR (HighValue - CurrentValue) > ToleranceValue 
	
	currentResult = CheckSize(CurrentValue, multipleLines)
	
	If currentResult Then 'this means currentvalue is too large
		HighValue = CurrentValue
	Else 'currentValue is too small
		LowValue = CurrentValue
	End If
	CurrentValue = (HighValue + LowValue)/2
Loop
mLbl.TextSize = CurrentValue - ToleranceValue
End Sub


Public Sub setText(value As String)
	mLbl.Text = value
	Dim multipleLines As Boolean = mLbl.Text.Contains(CRLF)
	Dim size As Float
	For size = 2 To 80
		If CheckSize(size, multipleLines) Then Exit
	Next
	size = size - 0.5
	If CheckSize(size, multipleLines) Then size = size - 0.5
	mLbl.TextSize = size
End Sub


'returns true if the size is too large
Private Sub CheckSize(size As Float, MultipleLines As Boolean) As Boolean
	mLbl.TextSize = size
	If MultipleLines Then
		Return su.MeasureMultilineTextHeight(mLbl, mLbl.Text) > mLbl.Height
	Else
		Return cvs.MeasureStringWidth(mLbl.Text, mLbl.Typeface, size) > mLbl.Width OR _
			su.MeasureMultilineTextHeight(mLbl, mLbl.Text) > mLbl.Height
	End If
End Sub

Public Sub getText As String
	Return mLbl.Text
End Sub